Makefile 35.5 KB
Newer Older
1
#
2 3 4
# This file is part of the flashrom project.
#
# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
5
# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
6 7 8 9 10 11 12 13 14 15 16 17 18
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
19
#
20

21
PROGRAM = flashrom
Ronald G. Minnich's avatar
Ronald G. Minnich committed
22

23 24 25 26 27 28
###############################################################################
# Defaults for the toolchain.

# If you want to cross-compile, just run e.g.
# make CC=i586-pc-msdosdjgpp-gcc
# You may have to specify STRIP/AR/RANLIB as well.
29 30 31
#
# Note for anyone editing this Makefile: gnumake will happily ignore any
# changes in this Makefile to variables set on the command line.
32
STRIP   ?= strip
33
INSTALL = install
34
DIFF    = diff
35
PREFIX  ?= /usr/local
36
MANDIR  ?= $(PREFIX)/share/man
37
CFLAGS  ?= -Os -Wall -Wshadow
38
EXPORTDIR ?= .
39
RANLIB  ?= ranlib
40 41
PKG_CONFIG ?= pkg-config
BUILD_DETAILS_FILE ?= build_details.txt
42

43 44 45 46 47 48 49 50 51 52 53 54
# The following parameter changes the default programmer that will be used if there is no -p/--programmer
# argument given when running flashrom. The predefined setting does not enable any default so that every
# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
# system attached to an external programmer while the default programmer is set to the internal programmer, and
# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
# values are those specified in enum programmer in programmer.h (which depend on other CONFIG_* options
# evaluated below, namely those that enable/disable the various programmers).
# Compilation will fail for unspecified values.
CONFIG_DEFAULT_PROGRAMMER ?= PROGRAMMER_INVALID
55 56 57 58 59
# The following adds a default parameter for the default programmer set above (only).
CONFIG_DEFAULT_PROGRAMMER_ARGS ?= ''
# Example: compiling with
#   make CONFIG_DEFAULT_PROGRAMMER=PROGRAMMER_SERPROG CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
60

61 62
# If your compiler spits out excessive warnings, run make WARNERROR=no
# You shouldn't have to change this flag.
63 64 65 66 67 68
WARNERROR ?= yes

ifeq ($(WARNERROR), yes)
CFLAGS += -Werror
endif

69
ifdef LIBS_BASE
70
CPPFLAGS += -I$(LIBS_BASE)/include
71 72 73
LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
endif
74

75 76 77 78 79
ifeq ($(CONFIG_STATIC),yes)
PKG_CONFIG += --static
LDFLAGS += -static
endif

80 81 82 83 84 85
# Set LC_ALL=C to minimize influences of the locale.
# However, this won't work for the majority of relevant commands because they use the $(shell) function and
# GNU make does not relay variables exported within the makefile to their evironment.
LC_ALL=C
export LC_ALL

86
dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
87 88 89

# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
# in the build details file together with the original stdout output.
90
debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(1) ; }' >&2;  { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
91

92
###############################################################################
93 94 95 96
# General OS-specific settings.
# 1. Prepare for later by gathering information about host and target OS
# 2. Set compiler flags and parameters according to OSes
# 3. Likewise verify user-supplied CONFIG_* variables.
97

98
# HOST_OS is only used to work around local toolchain issues.
99
HOST_OS ?= $(shell uname)
100 101 102 103 104
ifeq ($(HOST_OS), MINGW32_NT-5.1)
# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
CC = gcc
endif
ifneq ($(HOST_OS), SunOS)
105 106
STRIP_ARGS = -s
endif
107

108
# Determine the destination OS.
109 110 111
# IMPORTANT: The following line must be placed before TARGET_OS is ever used
# (of course), but should come after any lines setting CC because the line
# below uses CC itself.
112
override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
113 114

ifeq ($(TARGET_OS), Darwin)
115
CPPFLAGS += -I/opt/local/include -I/usr/local/include
116
LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauer's avatar
Stefan Reinauer committed
117
endif
118

119
ifeq ($(TARGET_OS), FreeBSD)
120
CPPFLAGS += -I/usr/local/include
121 122
LDFLAGS += -L/usr/local/lib
endif
123

124
ifeq ($(TARGET_OS), OpenBSD)
Carl-Daniel Hailfinger's avatar
Carl-Daniel Hailfinger committed
125 126 127
CPPFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
endif
128

Stefan Tauner's avatar
Stefan Tauner committed
129 130 131 132 133 134
ifeq ($(TARGET_OS), NetBSD)
CPPFLAGS += -I/usr/pkg/include
LDFLAGS += -L/usr/pkg/lib
endif

ifeq ($(TARGET_OS), DragonFlyBSD)
Stefan Tauner's avatar
Stefan Tauner committed
135 136
CPPFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
Stefan Tauner's avatar
Stefan Tauner committed
137 138
endif

139
ifeq ($(TARGET_OS), DOS)
140
EXEC_SUFFIX := .exe
141
# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
142
CFLAGS += -Wno-format
Stefan Tauner's avatar
Stefan Tauner committed
143
LIBS += -lgetopt
144
# Bus Pirate, Serprog and PonyProg are not supported under DOS (missing serial support).
145 146 147 148 149 150 151 152 153 154
ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
else
override CONFIG_BUSPIRATE_SPI = no
endif
ifeq ($(CONFIG_SERPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_SERPROG=yes
else
override CONFIG_SERPROG = no
endif
155 156 157 158 159
ifeq ($(CONFIG_PONY_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PONY_SPI=yes
else
override CONFIG_PONY_SPI = no
endif
160
# Dediprog, USB-Blaster, PICkit2 and FT2232 are not supported under DOS (missing USB support).
161 162 163 164 165 166 167 168 169 170
ifeq ($(CONFIG_DEDIPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
else
override CONFIG_DEDIPROG = no
endif
ifeq ($(CONFIG_FT2232_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
else
override CONFIG_FT2232_SPI = no
endif
171 172 173 174 175
ifeq ($(CONFIG_USBBLASTER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
else
override CONFIG_USBBLASTER_SPI = no
endif
176 177 178 179 180
ifeq ($(CONFIG_PICKIT2_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PICKIT2_SPI=yes
else
override CONFIG_PICKIT2_SPI = no
endif
181
endif
182

183 184 185
# FIXME: Should we check for Cygwin/MSVC as well?
ifeq ($(TARGET_OS), MinGW)
EXEC_SUFFIX := .exe
186
# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
187
FLASHROM_CFLAGS += -Dffs=__builtin_ffs
188 189 190
# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
# for MinGW. See http://sourceforge.net/apps/trac/mingw-w64/wiki/printf%20and%20scanf%20family */
FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224
# libusb-win32/libftdi stuff is usually installed in /usr/local.
CPPFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
ifeq ($(CONFIG_INTERNAL), yes)
UNSUPPORTED_FEATURES += CONFIG_INTERNAL=yes
else
override CONFIG_INTERNAL = no
endif
ifeq ($(CONFIG_RAYER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
else
override CONFIG_RAYER_SPI = no
endif
ifeq ($(CONFIG_NIC3COM), yes)
UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
else
override CONFIG_NIC3COM = no
endif
ifeq ($(CONFIG_GFXNVIDIA), yes)
UNSUPPORTED_FEATURES += CONFIG_GFXNVIDIA=yes
else
override CONFIG_GFXNVIDIA = no
endif
ifeq ($(CONFIG_SATASII), yes)
UNSUPPORTED_FEATURES += CONFIG_SATASII=yes
else
override CONFIG_SATASII = no
endif
ifeq ($(CONFIG_ATAHPT), yes)
UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
else
override CONFIG_ATAHPT = no
endif
225 226 227 228 229
ifeq ($(CONFIG_ATAVIA), yes)
UNSUPPORTED_FEATURES += CONFIG_ATAVIA=yes
else
override CONFIG_ATAVIA = no
endif
Kyösti Mälkki's avatar
Kyösti Mälkki committed
230 231 232 233 234
ifeq ($(CONFIG_IT8212), yes)
UNSUPPORTED_FEATURES += CONFIG_IT8212=yes
else
override CONFIG_IT8212 = no
endif
235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254
ifeq ($(CONFIG_DRKAISER), yes)
UNSUPPORTED_FEATURES += CONFIG_DRKAISER=yes
else
override CONFIG_DRKAISER = no
endif
ifeq ($(CONFIG_NICREALTEK), yes)
UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
else
override CONFIG_NICREALTEK = no
endif
ifeq ($(CONFIG_NICNATSEMI), yes)
UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
else
override CONFIG_NICNATSEMI = no
endif
ifeq ($(CONFIG_NICINTEL), yes)
UNSUPPORTED_FEATURES += CONFIG_NICINTEL=yes
else
override CONFIG_NICINTEL = no
endif
255 256 257 258 259
ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
UNSUPPORTED_FEATURES += CONFIG_NICINTEL_EEPROM=yes
else
override CONFIG_NICINTEL_EEPROM = no
endif
260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276
ifeq ($(CONFIG_NICINTEL_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_NICINTEL_SPI=yes
else
override CONFIG_NICINTEL_SPI = no
endif
ifeq ($(CONFIG_OGP_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_OGP_SPI=yes
else
override CONFIG_OGP_SPI = no
endif
ifeq ($(CONFIG_SATAMV), yes)
UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
else
override CONFIG_SATAMV = no
endif
endif

277
ifeq ($(TARGET_OS), libpayload)
278 279 280 281
ifeq ($(MAKECMDGOALS),)
.DEFAULT_GOAL := libflashrom.a
$(info Setting default goal to libflashrom.a)
endif
282
FLASHROM_CFLAGS += -DSTANDALONE
283 284 285 286 287
ifeq ($(CONFIG_DUMMY), yes)
UNSUPPORTED_FEATURES += CONFIG_DUMMY=yes
else
override CONFIG_DUMMY = no
endif
288
# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
289 290 291 292 293 294 295 296 297 298
ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
else
override CONFIG_BUSPIRATE_SPI = no
endif
ifeq ($(CONFIG_SERPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_SERPROG=yes
else
override CONFIG_SERPROG = no
endif
299 300 301 302 303
ifeq ($(CONFIG_PONY_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PONY_SPI=yes
else
override CONFIG_PONY_SPI = no
endif
304
# Dediprog, USB-Blaster, PICkit2 and FT2232 are not supported with libpayload (missing libusb support)
305 306 307 308 309 310 311 312 313 314
ifeq ($(CONFIG_DEDIPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
else
override CONFIG_DEDIPROG = no
endif
ifeq ($(CONFIG_FT2232_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
else
override CONFIG_FT2232_SPI = no
endif
315 316 317 318 319
ifeq ($(CONFIG_USBBLASTER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
else
override CONFIG_USBBLASTER_SPI = no
endif
320 321 322 323 324
ifeq ($(CONFIG_PICKIT2_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PICKIT2_SPI=yes
else
override CONFIG_PICKIT2_SPI = no
endif
325 326
endif

327 328 329 330 331 332
ifneq ($(TARGET_OS), Linux)
ifeq ($(CONFIG_LINUX_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_LINUX_SPI=yes
else
override CONFIG_LINUX_SPI = no
endif
333 334 335 336 337
ifeq ($(CONFIG_MSTARDDC_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_MSTARDDC_SPI=yes
else
override CONFIG_MSTARDDC_SPI = no
endif
338 339
endif

340 341 342 343
###############################################################################
# General architecture-specific settings.
# Like above for the OS, below we verify user-supplied options depending on the target architecture.

344 345 346
# Determine the destination processor architecture.
# IMPORTANT: The following line must be placed before ARCH is ever used
# (of course), but should come after any lines setting CC because the line
347
# below uses CC itself.
348
override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
349

Stefan Tauner's avatar
Stefan Tauner committed
350
# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
351 352
# Right now this means the drivers below only work on x86.
ifneq ($(ARCH), x86)
353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384
ifeq ($(CONFIG_NIC3COM), yes)
UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
else
override CONFIG_NIC3COM = no
endif
ifeq ($(CONFIG_NICREALTEK), yes)
UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
else
override CONFIG_NICREALTEK = no
endif
ifeq ($(CONFIG_NICNATSEMI), yes)
UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
else
override CONFIG_NICNATSEMI = no
endif
ifeq ($(CONFIG_RAYER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
else
override CONFIG_RAYER_SPI = no
endif
ifeq ($(CONFIG_ATAHPT), yes)
UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
else
override CONFIG_ATAHPT = no
endif
ifeq ($(CONFIG_SATAMV), yes)
UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
else
override CONFIG_SATAMV = no
endif
endif

385 386 387
###############################################################################
# Flash chip drivers and bus support infrastructure.

Stefan Tauner's avatar
Stefan Tauner committed
388
CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
389
	sst28sf040.o 82802ab.o \
390
	sst49lfxxxc.o sst_fwhub.o flashchips.o spi.o spi25.o spi25_statusreg.o \
391
	opaque.o sfdp.o en29lv640b.o at45db.o
392

393 394
###############################################################################
# Library code.
395

Stefan Tauner's avatar
Stefan Tauner committed
396
LIB_OBJS = layout.o flashrom.o udelay.o programmer.o helpers.o
397

398 399
###############################################################################
# Frontend related stuff.
400

401
CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
402

Stefan Tauner's avatar
Stefan Tauner committed
403
# Set the flashrom version string from the highest revision number of the checked out flashrom files.
404 405
# Note to packagers: Any tree exported with "make export" or "make tarball"
# will not require subversion. The downloadable snapshots are already exported.
Stefan Tauner's avatar
Stefan Tauner committed
406
SVNVERSION := $(shell ./util/getrevision.sh -u 2>/dev/null )
407

408
RELEASE := 0.9.8
Stefan Tauner's avatar
Stefan Tauner committed
409
VERSION := $(RELEASE)-$(SVNVERSION)
410
RELEASENAME ?= $(VERSION)
411 412

SVNDEF := -D'FLASHROM_VERSION="$(VERSION)"'
413

Stefan Tauner's avatar
Stefan Tauner committed
414 415
# Inform user if there is no meaningful version string. If there is version information from a VCS print
# something anyway because $(info...) will print a line break in any case which would look suspicious.
416 417 418
# The && between the echos is a workaround for old versions of GNU make that issue the error "unterminated
# variable reference" if a semicolon is used instead.
$(info $(shell ./util/getrevision.sh -c 2>/dev/null || echo "Files don't seem to be under version control." && \
Stefan Tauner's avatar
Stefan Tauner committed
419 420
	echo "Replacing all version templates with $(VERSION)." ))

421 422 423
###############################################################################
# Default settings of CONFIG_* variables.

424 425 426
# Always enable internal/onboard support for now.
CONFIG_INTERNAL ?= yes

Stefan Tauner's avatar
Stefan Tauner committed
427
# Always enable serprog for now.
428 429
CONFIG_SERPROG ?= yes

430 431 432
# RayeR SPIPGM hardware support
CONFIG_RAYER_SPI ?= yes

433 434 435
# PonyProg2000 SPI hardware support
CONFIG_PONY_SPI ?= yes

436 437 438
# Always enable 3Com NICs for now.
CONFIG_NIC3COM ?= yes

439 440
# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
CONFIG_GFXNVIDIA ?= yes
441

442 443 444
# Always enable SiI SATA controllers for now.
CONFIG_SATASII ?= yes

445 446 447 448
# Highpoint (HPT) ATA/RAID controller support.
# IMPORTANT: This code is not yet working!
CONFIG_ATAHPT ?= no

449 450 451
# VIA VT6421A LPC memory support
CONFIG_ATAVIA ?= yes

452
# Always enable FT2232 SPI dongles for now.
453
CONFIG_FT2232_SPI ?= yes
454

455 456 457
# Always enable Altera USB-Blaster dongles for now.
CONFIG_USBBLASTER_SPI ?= yes

458 459 460
# MSTAR DDC support needs more tests/reviews/cleanups.
CONFIG_MSTARDDC_SPI ?= no

461 462 463
# Always enable PICkit2 SPI dongles for now.
CONFIG_PICKIT2_SPI ?= yes

464 465 466 467 468
# Always enable dummy tracing for now.
CONFIG_DUMMY ?= yes

# Always enable Dr. Kaiser for now.
CONFIG_DRKAISER ?= yes
469

470 471 472
# Always enable Realtek NICs for now.
CONFIG_NICREALTEK ?= yes

473 474 475
# Disable National Semiconductor NICs until support is complete and tested.
CONFIG_NICNATSEMI ?= no

476 477 478
# Always enable Intel NICs for now.
CONFIG_NICINTEL ?= yes

479 480 481
# Always enable SPI on Intel NICs for now.
CONFIG_NICINTEL_SPI ?= yes

482 483 484
# Always enable EEPROM on Intel NICs for now.
CONFIG_NICINTEL_EEPROM ?= yes

485 486 487
# Always enable SPI on OGP cards for now.
CONFIG_OGP_SPI ?= yes

488
# Always enable Bus Pirate SPI for now.
489
CONFIG_BUSPIRATE_SPI ?= yes
490

491 492 493
# Disable Dediprog SF100 until support is complete and tested.
CONFIG_DEDIPROG ?= no

494 495 496
# Always enable Marvell SATA controllers for now.
CONFIG_SATAMV ?= yes

497 498 499
# Enable Linux spidev interface by default. We disable it on non-Linux targets.
CONFIG_LINUX_SPI ?= yes

Kyösti Mälkki's avatar
Kyösti Mälkki committed
500 501 502
# Always enable ITE IT8212F PATA controllers for now.
CONFIG_IT8212 ?= yes

503
# Disable wiki printing by default. It is only useful if you have wiki access.
504
CONFIG_PRINT_WIKI ?= no
505

506 507 508 509 510 511 512
# Enable all features if CONFIG_EVERYTHING=yes is given
ifeq ($(CONFIG_EVERYTHING), yes)
$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
	$(if $(filter no, $($(var))),\
		$(eval $(var)=yes)))
endif

513 514 515 516
# Bitbanging SPI infrastructure, default off unless needed.
ifeq ($(CONFIG_RAYER_SPI), yes)
override CONFIG_BITBANG_SPI = yes
else
517 518 519
ifeq ($(CONFIG_PONY_SPI), yes)
override CONFIG_BITBANG_SPI = yes
else
520 521 522 523 524 525
ifeq ($(CONFIG_INTERNAL), yes)
override CONFIG_BITBANG_SPI = yes
else
ifeq ($(CONFIG_NICINTEL_SPI), yes)
override CONFIG_BITBANG_SPI = yes
else
526 527 528
ifeq ($(CONFIG_OGP_SPI), yes)
override CONFIG_BITBANG_SPI = yes
else
529 530 531 532
CONFIG_BITBANG_SPI ?= no
endif
endif
endif
533
endif
534
endif
535

Sean Nelson's avatar
Sean Nelson committed
536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552
###############################################################################
# Handle CONFIG_* variables that depend on others set (and verified) above.

# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
ifeq ($(TARGET_OS), libpayload)
ifeq ($(CONFIG_INTERNAL), yes)
ifeq ($(CONFIG_INTERNAL_DMI), no)
UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
else
override CONFIG_INTERNAL_DMI = yes
endif
endif
endif

# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
CONFIG_INTERNAL_DMI ?= yes

553 554
###############################################################################
# Programmer drivers and programmer support infrastructure.
555
# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
556

557
FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER=$(CONFIG_DEFAULT_PROGRAMMER)'
558
FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
559

560
ifeq ($(CONFIG_INTERNAL), yes)
561
FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson's avatar
Sean Nelson committed
562
PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
563
ifeq ($(ARCH), x86)
564
PROGRAMMER_OBJS += it87spi.o it85spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Sean Nelson's avatar
Sean Nelson committed
565 566 567 568
PROGRAMMER_OBJS += ichspi.o ich_descriptors.o dmi.o
ifeq ($(CONFIG_INTERNAL_DMI), yes)
FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
endif
569 570
else
endif
571 572 573
NEED_PCI := yes
endif

574
ifeq ($(CONFIG_SERPROG), yes)
575
FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
576
PROGRAMMER_OBJS += serprog.o
577 578
NEED_SERIAL := yes
NEED_NET := yes
579
endif
580

581 582 583 584 585 586 587
ifeq ($(CONFIG_RAYER_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
PROGRAMMER_OBJS += rayer_spi.o
# Actually, NEED_PCI is wrong. NEED_IOPORT_ACCESS would be more correct.
NEED_PCI := yes
endif

588 589 590 591 592 593
ifeq ($(CONFIG_PONY_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
PROGRAMMER_OBJS += pony_spi.o
NEED_SERIAL := yes
endif

594
ifeq ($(CONFIG_BITBANG_SPI), yes)
595
FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
596
PROGRAMMER_OBJS += bitbang_spi.o
597 598
endif

599
ifeq ($(CONFIG_NIC3COM), yes)
600
FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
601
PROGRAMMER_OBJS += nic3com.o
602
NEED_PCI := yes
603
endif
604

605
ifeq ($(CONFIG_GFXNVIDIA), yes)
606
FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
607
PROGRAMMER_OBJS += gfxnvidia.o
608
NEED_PCI := yes
609 610
endif

611
ifeq ($(CONFIG_SATASII), yes)
612
FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
613
PROGRAMMER_OBJS += satasii.o
614
NEED_PCI := yes
615 616
endif

617
ifeq ($(CONFIG_ATAHPT), yes)
618
FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
619 620 621 622
PROGRAMMER_OBJS += atahpt.o
NEED_PCI := yes
endif

623 624 625 626 627 628
ifeq ($(CONFIG_ATAVIA), yes)
FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
PROGRAMMER_OBJS += atavia.o
NEED_PCI := yes
endif

Kyösti Mälkki's avatar
Kyösti Mälkki committed
629 630 631 632 633 634
ifeq ($(CONFIG_IT8212), yes)
FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
PROGRAMMER_OBJS += it8212.o
NEED_PCI := yes
endif

635
ifeq ($(CONFIG_FT2232_SPI), yes)
636
# This is a totally ugly hack.
637
FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
638 639 640 641 642 643
NEED_FTDI := yes
PROGRAMMER_OBJS += ft2232_spi.o
endif

ifeq ($(CONFIG_USBBLASTER_SPI), yes)
# This is a totally ugly hack.
644
FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
645 646 647 648
NEED_FTDI := yes
PROGRAMMER_OBJS += usbblaster_spi.o
endif

649 650 651 652 653 654
ifeq ($(CONFIG_PICKIT2_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
PROGRAMMER_OBJS += pickit2_spi.o
NEED_USB := yes
endif

655
ifeq ($(NEED_FTDI), yes)
656 657 658
FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
Alexandru Gagniuc's avatar
Alexandru Gagniuc committed
659
FEATURE_CFLAGS += $(FTDI_INCLUDES)
660
FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
661 662
# We can't set NEED_USB here because that would transform libftdi auto-enabling
# into a hard requirement for libusb, defeating the purpose of auto-enabling.
663 664 665
endif

ifeq ($(CONFIG_DUMMY), yes)
666
FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
667
PROGRAMMER_OBJS += dummyflasher.o
668 669 670
endif

ifeq ($(CONFIG_DRKAISER), yes)
671
FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
672
PROGRAMMER_OBJS += drkaiser.o
673
NEED_PCI := yes
674
endif
675

676
ifeq ($(CONFIG_NICREALTEK), yes)
677
FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
678 679 680 681
PROGRAMMER_OBJS += nicrealtek.o
NEED_PCI := yes
endif

682 683 684 685 686 687
ifeq ($(CONFIG_NICNATSEMI), yes)
FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
PROGRAMMER_OBJS += nicnatsemi.o
NEED_PCI := yes
endif

688 689 690 691 692 693
ifeq ($(CONFIG_NICINTEL), yes)
FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
PROGRAMMER_OBJS += nicintel.o
NEED_PCI := yes
endif

694 695 696 697 698 699
ifeq ($(CONFIG_NICINTEL_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
PROGRAMMER_OBJS += nicintel_spi.o
NEED_PCI := yes
endif

700 701 702 703 704 705
ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
PROGRAMMER_OBJS += nicintel_eeprom.o
NEED_PCI := yes
endif

706 707 708 709 710 711
ifeq ($(CONFIG_OGP_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
PROGRAMMER_OBJS += ogp_spi.o
NEED_PCI := yes
endif

712 713
ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
714
PROGRAMMER_OBJS += buspirate_spi.o
715
NEED_SERIAL := yes
716 717
endif

718
ifeq ($(CONFIG_DEDIPROG), yes)
719
FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
720
PROGRAMMER_OBJS += dediprog.o
721
NEED_USB := yes
722 723
endif

724 725 726 727 728 729
ifeq ($(CONFIG_SATAMV), yes)
FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
PROGRAMMER_OBJS += satamv.o
NEED_PCI := yes
endif

730
ifeq ($(CONFIG_LINUX_SPI), yes)
731
# This is a totally ugly hack.
732
FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
733 734 735
PROGRAMMER_OBJS += linux_spi.o
endif

736 737
ifeq ($(CONFIG_MSTARDDC_SPI), yes)
# This is a totally ugly hack.
738
FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
739 740 741 742
NEED_LINUX_I2C := yes
PROGRAMMER_OBJS += mstarddc_spi.o
endif

743
ifeq ($(NEED_SERIAL), yes)
744
LIB_OBJS += serial.o
745
endif
746

747
ifeq ($(NEED_NET), yes)
748
ifeq ($(TARGET_OS), SunOS)
749 750
LIBS += -lsocket
endif
751 752 753
endif

ifeq ($(NEED_PCI), yes)
754
CHECK_LIBPCI = yes
755
FEATURE_CFLAGS += -D'NEED_PCI=1'
756
FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
757

758
PROGRAMMER_OBJS += pcidev.o physmap.o hwaccess.o
759
ifeq ($(TARGET_OS), NetBSD)
760
# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
761
PCILIBS += -lpciutils -lpci
762
# For (i386|x86_64)_iopl(2).
763
PCILIBS += -l$(shell uname -p)
764
else
765

766
PCILIBS += -lpci
767

768
ifeq ($(TARGET_OS), OpenBSD)
Carl-Daniel Hailfinger's avatar
Carl-Daniel Hailfinger committed
769
# For (i386|amd64)_iopl(2).
770
PCILIBS += -l$(shell uname -m)
771 772 773
else
ifeq ($(TARGET_OS), Darwin)
# DirectHW framework can be found in the DirectHW library.
774
PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfinger's avatar
Carl-Daniel Hailfinger committed
775
endif
776
endif
Jonathan A. Kollasch's avatar
Jonathan A. Kollasch committed
777
endif
778 779
endif

780 781 782
ifeq ($(NEED_USB), yes)
CHECK_LIBUSB0 = yes
FEATURE_CFLAGS += -D'NEED_USB=1'
783
USBLIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libusb || printf "%s" "-lusb")
784 785
endif

786
ifeq ($(CONFIG_PRINT_WIKI), yes)
787
FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
788
CLI_OBJS += print_wiki.o
789 790
endif

791
FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
792

793
# We could use PULLED_IN_LIBS, but that would be ugly.
794
FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
795

796
LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
797
OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
798

799
all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
800 801 802 803
ifeq ($(ARCH), x86)
	@+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
endif

804
$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
805
	$(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS)
806

807 808 809 810
libflashrom.a: $(LIBFLASHROM_OBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

811 812 813 814
# TAROPTIONS reduces information leakage from the packager's system.
# If other tar programs support command line arguments for setting uid/gid of
# stored files, they can be handled here as well.
TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
815

816
%.o: %.c .features
817
	$(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SVNDEF) -o $@ -c $<
818

819 820
# Make sure to add all names of generated binaries here.
# This includes all frontends and libflashrom.
821
# We don't use EXEC_SUFFIX here because we want to clean everything.
822
clean:
823
	rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
824
	@+$(MAKE) -C util/ich_descriptors_tool/ clean
825 826

distclean: clean
827
	rm -f .features .libdeps
828

829 830
strip: $(PROGRAM)$(EXEC_SUFFIX)
	$(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
831

832 833 834 835 836 837 838 839 840 841 842 843 844
# to define test programs we use verbatim variables, which get exported
# to environment variables and are referenced with $$<varname> later

define COMPILER_TEST
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	return 0;
}
endef
export COMPILER_TEST

845
compiler: featuresavailable
846
	@printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
847
	@echo "$$COMPILER_TEST" > .test.c
848 849 850
	@{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
		echo "found." || { echo "not found."; \
		rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
851
	@rm -f .test.c .test$(EXEC_SUFFIX)
852
	@printf "Target arch is "
853
	@# FreeBSD wc will output extraneous whitespace.
854
	@echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' ||	\
855 856
		( echo "unknown. Aborting."; exit 1)
	@printf "%s\n" '$(ARCH)'
857 858 859 860 861
	@printf "Target OS is "
	@# FreeBSD wc will output extraneous whitespace.
	@echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' ||	\
		( echo "unknown. Aborting."; exit 1)
	@printf "%s\n" '$(TARGET_OS)'
862 863 864 865 866
ifeq ($(TARGET_OS), libpayload)
	@$(CC) --version 2>&1 | grep -q coreboot || \
		( echo "Warning: It seems you are not using coreboot's reference compiler."; \
		  echo "This might work but usually does not, please beware." )
endif
867

868 869 870
define LIBPCI_TEST
/* Avoid a failing test due to libpci header symbol shadowing breakage */
#define index shadow_workaround_index
Stefan Tauner's avatar
Stefan Tauner committed
871
#if !defined __NetBSD__
872
#include <pci/pci.h>
Stefan Tauner's avatar
Stefan Tauner committed
873 874 875
#else
#include <pciutils/pci.h>
#endif
876 877 878 879 880 881 882 883 884 885 886
struct pci_access *pacc;
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	pacc = pci_alloc();
	return 0;
}
endef
export LIBPCI_TEST

887 888 889 890 891 892 893 894 895 896 897 898 899 900 901 902 903 904 905 906 907
define PCI_GET_DEV_TEST
/* Avoid a failing test due to libpci header symbol shadowing breakage */
#define index shadow_workaround_index
#if !defined __NetBSD__
#include <pci/pci.h>
#else
#include <pciutils/pci.h>
#endif
struct pci_access *pacc;
struct pci_dev *dev = {0};
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	pacc = pci_alloc();
	dev = pci_get_dev(pacc, dev->domain, dev->bus, dev->dev, 1);
	return 0;
}
endef
export PCI_GET_DEV_TEST

908
define LIBUSB0_TEST
909 910 911 912
#include "platform.h"
#if IS_WINDOWS
#include <lusb0_usb.h>
#else
913
#include <usb.h>
914
#endif
915 916 917 918 919 920 921 922 923 924 925 926
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	usb_init();
	return 0;
}
endef
export LIBUSB0_TEST

hwlibs: compiler
	@printf "" > .libdeps
927
ifeq ($(CHECK_LIBPCI), yes)
928
	@printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
929
	@echo "$$LIBPCI_TEST" > .test.c
930 931 932
	@{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
		echo "found." || { echo "not found."; echo;			\
		echo "Please install libpci headers."; \
933
		echo "See README for more information."; echo;			\
934 935
		rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
	@printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
936
	@echo "$$PCI_GET_DEV_TEST" > .test.c
937
	@ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
938
		( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) ||	\
939 940 941 942 943 944 945
		( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
	@printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
	@{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
		echo "yes." || { echo "no.";							\
		printf "Checking if libz+libpci are present and sufficient..." ; \
		{ $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
		echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo;	\
946
		echo "Please install libpci (package pciutils) and/or libz.";			\
947
		echo "See README for more information."; echo;				\
948
		rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
949
	@rm -f .test.c .test.o .test$(EXEC_SUFFIX)
950 951
endif
ifeq ($(CHECK_LIBUSB0), yes)
952
	@printf "Checking for libusb-0.1/libusb-compat headers... " | tee -a $(BUILD_DETAILS_FILE)
953
	@echo "$$LIBUSB0_TEST" > .test.c
954 955
	@{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
		echo "found." || { echo "not found."; echo;				\
956 957
		echo "Please install libusb-0.1 headers or libusb-compat headers.";	\
		echo "See README for more information."; echo;				\
958 959 960 961
		rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
	@printf "Checking if libusb-0.1 is usable... " | tee -a $(BUILD_DETAILS_FILE)
	@{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USBLIBS) >&2 && \
		echo "yes." || { echo "no.";						\
962 963
		echo "Please install libusb-0.1 or libusb-compat.";			\
		echo "See README for more information."; echo;				\
964
		rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
965
	@rm -f .test.c .test.o .test$(EXEC_SUFFIX)
966
endif
967

968 969
.features: features

970 971 972
# If a user does not explicitly request a non-working feature, we should
# silently disable it. However, if a non-working (does not compile) feature
# is explicitly requested, we should bail out with a descriptive error message.
973
# We also have to check that at least one programmer driver is enabled.
974
featuresavailable:
975 976 977 978 979
ifeq ($(PROGRAMMER_OBJS),)
	@echo "You have to enable at least one programmer driver!"
	@false
endif
ifneq ($(UNSUPPORTED_FEATURES), )
980 981 982 983
	@echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
	@false
endif

984
define FTDI_TEST
985
#include <stdlib.h>
986 987 988 989 990 991 992 993 994 995 996
#include <ftdi.h>
struct ftdi_context *ftdic = NULL;
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	return ftdi_init(ftdic);
}
endef
export FTDI_TEST

997 998 999 1000 1001 1002
define FTDI_232H_TEST
#include <ftdi.h>
enum ftdi_chip_type type = TYPE_232H;
endef
export FTDI_232H_TEST

1003 1004 1005 1006 1007 1008 1009 1010 1011 1012 1013 1014 1015
define UTSNAME_TEST
#include <sys/utsname.h>
struct utsname osinfo;
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	uname (&osinfo);
	return 0;
}
endef
export UTSNAME_TEST

1016 1017 1018 1019 1020 1021 1022 1023 1024 1025 1026 1027 1028
define LINUX_SPI_TEST
#include <linux/types.h>
#include <linux/spi/spidev.h>

int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	return 0;
}
endef
export LINUX_SPI_TEST

1029 1030 1031 1032 1033 1034 1035 1036 1037 1038 1039 1040 1041
define LINUX_I2C_TEST
#include <linux/i2c-dev.h>
#include <linux/i2c.h>

int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	return 0;
}
endef
export LINUX_I2C_TEST

1042 1043
features: compiler
	@echo "FEATURES := yes" > .features.tmp
1044
ifeq ($(NEED_FTDI), yes)
1045
	@printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
1046
	@echo "$$FTDI_TEST" > .featuretest.c
1047 1048 1049 1050 1051 1052 1053 1054 1055 1056
	@ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
	(	echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
		printf "Checking for FT232H support in libftdi... " ; \
		echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
		{ $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
			( echo "found."; echo "FT232H := yes" >> .features.tmp ) ||	\
			( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
	) || \
	( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
	2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1057 1058
endif
ifeq ($(CONFIG_LINUX_SPI), yes)
1059
	@printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
1060
	@echo "$$LINUX_SPI_TEST" > .featuretest.c
1061
	@ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1062
		( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) ||	\
1063 1064
		( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
		2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1065 1066
endif
ifeq ($(NEED_LINUX_I2C), yes)
1067
	@printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
1068
	@echo "$$LINUX_I2C_TEST" > .featuretest.c
1069
	@ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1070
		( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) ||	\
1071 1072
		( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
		2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1073
endif
1074
	@printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
1075
	@echo "$$UTSNAME_TEST" > .featuretest.c
1076
	@ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1077
		( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) ||	\
1078
		( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1079
	@$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1080
	@rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
1081

1082 1083 1084
$(PROGRAM).8.html: $(PROGRAM).8
	@groff -mandoc -Thtml $< >$@

1085
$(PROGRAM).8: $(PROGRAM).8.tmpl
1086 1087
	@# Add the man page change date and version to the man page
	@sed -e 's#.TH FLASHROM 8 ".*".*#.TH FLASHROM 8 "$(shell ./util/getrevision.sh -d $(PROGRAM).8.tmpl 2>/dev/null)" "$(VERSION)"#' <$< >$@
1088 1089

install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
1090
	mkdir -p $(DESTDIR)$(PREFIX)/sbin
1091
	mkdir -p $(DESTDIR)$(MANDIR)/man8
1092
	$(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
1093
	$(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
1094

1095
export: $(PROGRAM).8
1096 1097 1098
	@rm -rf $(EXPORTDIR)/flashrom-$(RELEASENAME)
	@svn export -r BASE . $(EXPORTDIR)/flashrom-$(RELEASENAME)
	@sed "s/^SVNVERSION.*/SVNVERSION := $(SVNVERSION)/" Makefile >$(EXPORTDIR)/flashrom-$(RELEASENAME)/Makefile
1099
	@cp $(PROGRAM).8 "$(EXPORTDIR)/flashrom-$(RELEASENAME)/$(PROGRAM).8"
1100
	@svn log >$(EXPORTDIR)/flashrom-$(RELEASENAME)/ChangeLog
1101
	@echo Exported $(EXPORTDIR)/flashrom-$(RELEASENAME)/
1102 1103

tarball: export
1104 1105 1106
	@tar cjf $(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2 -C $(EXPORTDIR)/ $(TAROPTIONS) flashrom-$(RELEASENAME)/
	@rm -rf $(EXPORTDIR)/flashrom-$(RELEASENAME)
	@echo Created $(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2
1107

1108
djgpp-dos: clean
1109 1110 1111
	make CC=i586-pc-msdosdjgpp-gcc STRIP=i586-pc-msdosdjgpp-strip
libpayload: clean
	make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
1112

1113
.PHONY: all install clean distclean compiler hwlibs features export tarball djgpp-dos featuresavailable libpayload
1114

1115
-include $(OBJS:.o=.d)